/*  Gtk+ Widget Factory
 *  Copyright (C) 1999-2000  Jeroen Benckhuijsen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef GWF_SETTINGS_H
#define GWF_SETTINGS_H

#ifdef __cplusplus
extern "C" {
#endif

#include <gtk/gtk.h>
#include "gwf_projlist.h"

typedef struct	_GwfSettings		GwfSettings;
typedef struct	_GwfSettingsList	GwfSettingsList;

typedef GtkWidget*	(*GwfSettingsCreate)		(GwfProjlist *projlist);
typedef void		(*GwfSettingsForeachFunc)	(GwfSettings *settings,gpointer user_data);

struct _GwfSettings
{
   gchar		*name;

   GwfSettingsCreate	create;
};

struct _GwfSettingsList
{
   GHashTable		*settings;
};

GwfSettingsList*	gwf_settingslist_new		(void);
void			gwf_settingslist_free		(GwfSettingsList *list);
gint			gwf_settingslist_add		(GwfSettingsList *list,GwfSettings *settings);
void			gwf_settingslist_remove		(GwfSettingsList *list,gchar *name);
GwfSettings*		gwf_settingslist_get		(GwfSettingsList *list,gchar *name);
void			gwf_settingslist_foreach	(GwfSettingsList *list,GwfSettingsForeachFunc func,gpointer user_data);

GwfSettings*		gwf_settings_new		(gchar *name);
void			gwf_settings_free		(GwfSettings *settings);
void			gwf_settings_set_create		(GwfSettings *settings,GwfSettingsCreate func);

GtkWidget*		gwf_settings_create		(GwfSettings *settings,GwfProjlist *projlist);

#ifdef __cplusplus
}
#endif

#endif

